<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/FileTree.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/FileTree.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/FileTree.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno"> 8</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> Tree <span class="py-keyword">import</span> Tree</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-keyword">import</span> os</span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileTree/FileTree.html">FileTree</a>(Tree):</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Create a javascript-enabled file tree.&quot;&quot;&quot;</span></span>
<a id="line17"></a><span class="lineno">17</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">    link_to_views = Parameter(False, <span class="py-string">'some docs...'</span>)</span>
<a id="line19"></a><span class="lineno">19</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileTree/FileTree.html#filename">filename</a>(self):</span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        <span class="py-keyword">if</span> self.main:</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">            <span class="py-keyword">return</span> self.directory_layout.index()</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">            <span class="py-keyword">return</span> self.directory_layout.special(<span class="py-string">'FileTree'</span>)</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileTree/FileTree.html#title">title</a>(self):</span>
<a id="line28"></a><span class="lineno">28</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'File Tree'</span></span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileTree/FileTree.html#root">root</a>(self):</span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">        <span class="py-keyword">return</span> self.filename(), self.title()</span>
<a id="line34"></a><span class="lineno">34</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileTree/FileTree.html#process">process</a>(self):</span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        <span class="py-comment"># Start the file</span></span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        self.start_file()</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">        self.write_navigation_bar()</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        <span class="py-comment"># recursively visit all nodes</span></span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        self.process_node(self.processor.file_tree)</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        self.end_tree()</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">        self.end_file()</span>
<a id="line44"></a><span class="lineno">44</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileTree/FileTree.html#process_node">process_node</a>(self, node):</span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        <span class="py-keyword">def</span> node_cmp(a, b):</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">            a_leaf = hasattr(a, <span class="py-string">'declarations'</span>)</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">            b_leaf = hasattr(b, <span class="py-string">'declarations'</span>)</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">            <span class="py-keyword">if</span> a_leaf != b_leaf:</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">                <span class="py-keyword">return</span> cmp(b_leaf, a_leaf)</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">            <span class="py-keyword">return</span> cmp(a.path[-1].upper(), b.path[-1].upper())</span>
<a id="line53"></a><span class="lineno">53</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">        dirname, filename = os.path.split(node.path)</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">        <span class="py-keyword">if</span> hasattr(node, <span class="py-string">'declarations'</span>):</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">            <span class="py-comment"># Leaf node</span></span>
<a id="line57"></a><span class="lineno">57</span><span class="line">            text = href(self.directory_layout.file_index(node.path),</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">                        filename, target=<span class="py-string">'detail'</span>)</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">            self.write_leaf(text)</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        <span class="py-comment"># Non-leaf node</span></span>
<a id="line62"></a><span class="lineno">62</span><span class="line">        children = node.children[:]</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">        children.sort(node_cmp)</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">        <span class="py-keyword">if</span> node.path:</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">            self.write_node_start(filename + os.sep)</span>
<a id="line66"></a><span class="lineno">66</span><span class="line">        <span class="py-keyword">if</span> len(children):</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">            <span class="py-keyword">for</span> child <span class="py-keyword">in</span> children:</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">                <span class="py-comment"># self.write('&lt;div class=&quot;files&quot;&gt;')</span></span>
<a id="line69"></a><span class="lineno">69</span><span class="line">                self.process_node(child)</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">                <span class="py-comment"># self.write('&lt;/div&gt;')</span></span>
<a id="line71"></a><span class="lineno">71</span><span class="line">        <span class="py-keyword">if</span> node.path:</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">            self.write_node_end()</span>
<a id="line73"></a><span class="lineno">73</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
